# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2020 Michael Inden

def calc_permutations(input):
    # $\mbox{\bfseries recursive termination}$
    if is_blank(input) or len(input) == 1:
        return {input}

    combinations = set()
    # $\mbox{\bfseries extract i-th character as new first character}$
    for i, new_first in enumerate(input):
        # $\mbox{\bfseries recursive descent for rest without i-th character}$
        permutations = calc_permutations(input[0:i] + input[i + 1:])

        # $\mbox{\bfseries adding the extracted character to all partial solutions}$
        for perm in permutations:
            combinations.add(new_first + perm)

    return combinations


def is_blank(my_string):
    return not (my_string and my_string.strip())


print(calc_permutations("ABC"))
print(calc_permutations("ACA"))
print(calc_permutations("ABCD"))
print(calc_permutations("ACAA"))
