# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2021 Michael Inden

class SuperHero:
    def __init__(self, name, superpower, strength):
        self.name = name
        self.superpower = superpower
        self.strength = strength

    def __str__(self):
        return f"{self.name} has {self.superpower} of strengths {self.strength}"

    def is_stronger_than(self, other):
        return self.strength > other.strength

    def strongest_of(*heros):
        strongest_hero = None
        for hero in heros:
            if strongest_hero is None or hero.is_stronger_than(strongest_hero):
                strongest_hero = hero
        return strongest_hero

    #
    def __eq__(self, other):
        if not isinstance(other, SuperHero):
            return False

        return self.name == other.name and \
               self.superpower == other.superpower and \
               self.strength == other.strength


def main():
    superman = SuperHero("Superman", "Kryptonite-Power", 1_000)
    batman = SuperHero("Batman", "Techno-Power", 100)
    ironman = SuperHero("Ironman", "Techno-Power", 500)

    print("Superman stronger than Batman?",
          superman.is_stronger_than(batman))
    print(SuperHero.strongest_of(superman, batman, ironman))


if __name__ == '__main__':
    main()
