# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2021 Michael Inden

class Car:
    def __init__(self, brand, color, horse_power):
        self.brand = brand
        self.color = color
        self.horse_power = horse_power

    def __str__(self):
        return f"Marke: {self.brand} / Farbe: {self.color} / PS: {self.horse_power}"

    def __repr__(self):
        return self.__str__()

    def paint_with(self, new_color):
        self.color = new_color

    def apply_tuning_kit(self):
        self.horse_power += 150

    def __eq__(self, other):
        if not isinstance(other, Car):
            return False

        return self.brand == other.brand and \
               self.color == other.color and \
               self.horse_power == other.horse_power


toms_car = Car("Audi", "BLUE", 275)
jims_car = Car("Audi", "BLUE", 275)
print(toms_car == jims_car)
print(toms_car is jims_car)
print(None == toms_car)
print(toms_car == None)


def is_equal_within_precision(value, expected, epsilon):
    return expected - epsilon < value < expected + epsilon


print(is_equal_within_precision(0.75, 0.7, 0.1))
print(is_equal_within_precision(0.725, 0.72, 0.005))
print(is_equal_within_precision(0.725, 0.72, 0.0051))
