# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2021 Michael Inden

class SimplePerson:
    def __init__(self, name, age):
        self.name = name
        self.age = age

    def __repr__(self):
        return f"{self.name} {self.age}"

    def __lt__(self, other):
        return self.name < other.name or \
               (self.name == other.name and self.age < other.age)


persons = [SimplePerson("Mike", 50), SimplePerson("Jim", 7),
           SimplePerson("Tim", 50), SimplePerson("John", 14),
           SimplePerson("Peter", 50), SimplePerson("Fred", 14),
           SimplePerson("Peter", 40), SimplePerson("Peter", 55)]

# persons.sort()
print(persons)

sorted_by_name_and_age = sorted(persons, key=lambda person: (person.name, person.age))
print(sorted_by_name_and_age)

sorted_by_age_and_name = sorted(persons, key=lambda person: (person.age, person.name))
print(sorted_by_age_and_name)

persons.sort()
print(persons)
