# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2021 Michael Inden

class Stack:
    def __init__(self):
        self._values = []

    def push(self, elem):
        self._values.append(elem)

    def pop(self):
        if self.is_empty():
            raise StackIsEmptyException()

        return self._values.pop()

    def peek(self):
        if self.is_empty():
            raise StackIsEmptyException()

        return self._values[-1]

    def is_empty(self):
        return len(self._values) == 0


class StackIsEmptyException(Exception):
    pass


numbers = [1, 2, 3, 4, 5, 6, 7]


def reverse_order(values):
    stack = Stack()
    for val in values:
        stack.push(val)

    result = []
    while not stack.is_empty():
        result.append(stack.pop())

    return result


reversed_numbers = reverse_order(numbers)
print(reversed_numbers)
