# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2021 Michael Inden

def filter_dict(input_dict, key_value_condition):
    filtered_dict = dict()
    for key, value in input_dict.items():
        if key_value_condition((key, value)):
            filtered_dict[key] = value
    return filtered_dict


def filter_by_value(input_dict, value_condition):
    filtered_result = filter_dict(input_dict,
                                  lambda entry: value_condition(entry[1]))
    return filtered_result


cities_sizes = {"Köln": 1_000_000, "Kiel": 250_000, "Bremen": 550_000,
                "Zürich": 400_000, "Oldenburg": 170_000}

print(filter_dict(cities_sizes, lambda entry: entry[0] in ["Kiel", "Köln"] or
                                              200_000 <= entry[1] <= 700_000))

print(filter_by_value(cities_sizes,
                      lambda size: 200_000 <= size <= 700_000))

person_hobbies = {"Tim": ["Java", "Music"],
                  "Peter": ["Python", "Movies"],
                  "Michael": ["Java", "Python", "Reading"],
                  "James": ["Music", "Movies"]}

print(filter_dict(person_hobbies, lambda entry: entry[0] in ["James"] or
                                                "Java" in entry[1]))

print(filter_by_value(person_hobbies,
                      lambda hobbies: (set(hobbies) & {"Music", "Movies"}) != set()))

print(filter_by_value(person_hobbies,
                      lambda hobbies: (set(hobbies) & {"Music", "Movies"}) == set()))


def filter_by_key(input_dict, key_condition):
    filtered_result = filter_dict(input_dict,
                                  lambda entry: key_condition(entry[0]))
    return filtered_result


print(filter_by_key(person_hobbies,
                    lambda name: name in ["James", "Tim"]))
