# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2021 Michael Inden

class EveryNth:
    def __init__(self, values, step=1):
        self.values = values
        self.step = step
        self.pos = 0

    def __iter__(self):
        return self

    def __next__(self):
        if self.pos >= len(self.values):
            raise StopIteration

        result = self.values[self.pos]
        self.pos += self.step
        return result


numbers = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]
for name in EveryNth(numbers, 2):
    print(name)

for name in EveryNth(numbers, 3):
    print(name)
