# Beispielprogramm für das Buch "Einfach Python"
#
# (C) 2021 Michael Inden

from itertools import groupby

things = [("animal", "Bear"), ("sport", "Golf"), ("sport", "Karate"),
          ("sport", "Bowling"), ("vehicle", "Bicycle"), ("animal", "Dog"),
          ("vehicle", "Car"), ("animal", "Tiger")]

for key, group in groupby(things, lambda entry: entry[0]):
    for entry in group:
        print("%s is a %s. (Key: %s)" % (entry[1], entry[0], key))
    print("")

sorted_things = sorted(things, key=lambda entry: entry[0])
for key, group in groupby(sorted_things, lambda entry: entry[0]):
    print("KEY:", key)
    for entry in group:
        print(entry[1], end=",")
    print("")

for key, group in groupby(things, lambda entry: entry[0]):
    listOfThings = " and ".join([entry[1] for entry in group])
    print(key + "s:  " + listOfThings + ".")

result = {}
extract_category = lambda entry: entry[0]
for key, group in groupby(things, extract_category):
    members = result.get(key, []) + list(group)
    result.update({key: members})
print(result)

result = {}
extract_category = lambda entry: entry[0]
for key, group in groupby(things, extract_category):
    members = result.get(key, []) + \
              list([thing[1] for thing in group])
    result.update({key: members})

print(result)
